#ifndef CUBE_HPP_INCLUDED
#define CUBE_HPP_INCLUDED


#include"imp.hpp"
#include"palette.hpp"
#include"rep.hpp"
#include"controller.hpp"
#include"stream.hpp"




class Stream;


struct
Cube
{
  static constexpr int  side_length = 12;

  static constexpr int  size=13;

  static Point3D  current_point;

  static constexpr RenderingParameter
  get_rendparam()
  {
    return RenderingParameter(side_length*size,side_length*size,side_length*size);
  }

  std::u16string  name_;

  Palette  palette_;

  enum class
  Mark: uint8_t
  {
    unuse,
    paint,
    paste,

  };


  struct Element{
    Mark      mark=Mark::unuse;
    uint8_t  index=0;
  };


  Element  elements_[size*size*size];

  struct Backup{
    uint8_t  data[sizeof(Element)*size*size*size];
  };


  PixelMap16  thumbnail_;


  Cube(                );
  Cube(const Cube&  rhs);

        Element&  get(int  x, int  y, int  z)      ;
  const Element&  get(int  x, int  y, int  z) const;

  Backup*  create_backup() const;

  void  operator=(const Cube&  rhs);
  void  operator=(const Backup*  bk);

  void  revolve_horizontally();
  void  revolve_vertically();

  void  update(                                         )      ;
  void  update(Drawer&  dr, bool  xyz, bool  frame=false) const;

  bool  process(const Controller&  ctrl, Mark  mark, int  i);

  static void  unlock();

  static const int  width;
  static const int  height;

  static void  draw(Drawer&  dr, void*  data, int  item_index, int  x, int  y);


  void  load(Stream&  src)      ;
  void  save(Stream&  dst) const;

  void  save_as_png() const;

};


enum{
  cube_table_size = 80,
};


extern Cube  cube_table[cube_table_size];


#endif




