#include"cube.hpp"




void
Cube::
load(Stream&  src)
{
  std::memset(&elements_,0,sizeof(elements_));

  name_.clear();

  src.read(name_);

  palette_.load(src);

    for(;;)
    {
      const unsigned int  em = src.get();

        if(!em)
        {
          break;
        }


      const int  ei = src.get();

      const int  i = src.get_be16();

      auto&  e = elements_[i];

      e.mark = static_cast<Mark>(em);

      e.index = ei;
    }


  update();
}


void
Cube::
save(Stream&  dst) const
{
  dst.write(name_);

  palette_.save(dst);

    for(auto&  e: elements_)
    {
        if(e.mark != Mark::unuse)
        {
          dst.put((int)e.mark );
          dst.put(     e.index);

          dst.put_be16((&e)-(&elements_[0]));
        }
    }


  dst.put(0);
}





void
Cube::
save_as_png() const
{
  auto  p = new uint32_t[get_rendparam().width*get_rendparam().height];

  char  buf[256];

  snprintf(buf,sizeof(buf),"__IMP%03d_%s.png",(this-&cube_table[0]),to_string(name_).data());

  Drawer  dr(p,get_rendparam().width,get_rendparam().height,sizeof(uint32_t)*get_rendparam().width);

  dr.fill();

  update(dr,false,false);

  dr.save(buf);

  delete[] p;
}




