#include"cube.hpp"
#include"cuberenderer.hpp"
#include<algorithm>




void
Cube::
update()
{
  CubeRenderer::clear();

    rep(z,size){
    rep(y,size){
    rep(x,size){
      auto&  elm = get(x,y,z);

        if(elm.mark != Mark::unuse)
        {
          CubeRenderer::push(palette_,elm,x,y,z);
        }
    }}}


  CubeRenderer::output(thumbnail_);
}




void
Cube::
update(Drawer&  dr, bool  xyz, bool  frame) const
{
    if(frame)
    {
      dr.draw_rect(0xFFFFFFFF,0,0,get_rendparam().width,get_rendparam().height);
    }


  CubeRenderer::clear();

  bool  found_flag = false;

    rep(z,size){
    rep(y,size){
    rep(x,size){
      auto&  elm = get(x,y,z);

        if(elm.mark != Mark::unuse)
        {
          auto&  focus = CubeRenderer::push(palette_,elm,x,y,z);

            if(xyz)
            {
                if(!found_flag &&
                    ((current_point.x == x) &&
                     (current_point.y == y) &&
                     (current_point.z == z)))
                {
                  found_flag = true;

                  focus = 1;
                }
            }
        }
    }}}


    if(xyz && !found_flag)
    {
      auto&  current = get(current_point.x,
                           current_point.y,
                           current_point.z);

      CubeRenderer::push(palette_,current,current_point.x,
                                          current_point.y,
                                          current_point.z) = 1;
    }


  CubeRenderer::output(dr);

    if(xyz)
    {
      dr.draw_formatted(0xFFFFFFFF,0,          0,"X %2d",current_point.x);
      dr.draw_formatted(0xFFFFFFFF,0,font_size  ,"Y %2d",current_point.y);
      dr.draw_formatted(0xFFFFFFFF,0,font_size*2,"Z %2d",current_point.z);
    }
}




