#ifndef CUBERENDERER_HPP_INCLUDED
#define CUBERENDERER_HPP_INCLUDED


#include"imp.hpp"
#include"cube.hpp"




struct
CubeRenderer
{
  static void  draw_frame(Drawer&  dr, int  x, int  y, Dir  dir);

  static void    fill_top_plane(PixelMap16&  dst, pixel16_t  pixel, int  x=0, int  y=0);
  static void  fill_front_plane(PixelMap16&  dst, pixel16_t  pixel, int  x=0, int  y=0);
  static void  fill_right_plane(PixelMap16&  dst, pixel16_t  pixel, int  x=0, int  y=0);

  static void    fill_top_plane(Drawer&  dst, pixel16_t  pixel, int  x=0, int  y=0);
  static void  fill_front_plane(Drawer&  dst, pixel16_t  pixel, int  x=0, int  y=0);
  static void  fill_right_plane(Drawer&  dst, pixel16_t  pixel, int  x=0, int  y=0);

  static int&  push(const Palette&  pal, const Cube::Element&  e, int  x, int  y, int  z);

  static void  clear();

  static void  output(PixelMap16&  dst);
  static void  output(Drawer&  dr);

};




#endif




