#include"cuberenderer.hpp"
#include"framerenderer.hpp"




void
CubeRenderer::
draw_frame(Drawer&  dr, int  x, int  y, Dir  dir)
{
  using ID = FrameRenderer<Drawer>::FrameID;

    switch(dir)
    {
      case(Dir::front):
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::right_left);
        break;
      case(Dir::back):
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::right_right);
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::top_back   );
        break;
      case(Dir::left):
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::front_left);
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::top_left  );
        break;
      case(Dir::right):
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::front_right);
        break;
      case(Dir::top):
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::top_front);
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::top_right);
        break;
      case(Dir::bottom):
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::front_bottom);
        FrameRenderer<Drawer>::draw_frame(dr,Cube::side_length,x,y,ID::right_bottom);
        break;
      default:;
    }
}




