#ifndef FRAMERENDERER_HPP_INCLUDED
#define FRAMERENDERER_HPP_INCLUDED


#include<cstdint>




template<typename  T>
struct
FrameRenderer
{
  static constexpr uint32_t  pixel = 0xFFFFFFFF;


static
void
draw_dline(T&  dst, int  side_length, int  x, int  y, int  xmod, int  ymod)
{
  dst.draw_point(pixel,x,y);

  x += xmod;
  y += ymod;

    for(int  n = (side_length/2)-1;  n--;)
    {
      dst.draw_hline(pixel,x,y,2);

      x += xmod*2;
      y += ymod  ;

    }


  dst.draw_point(pixel,x,y);
}


static
void
draw_dline2(T&  dst, int  side_length, int  x, int  y, int  xmod, int  ymod)
{
    for(int  n = (side_length/2);  n--;)
    {
      dst.draw_hline(pixel,x,y,2);

      x += xmod*2;
      y += ymod  ;
    }
}


enum class FrameID{
  top_back,
  top_left,
  top_right,
  top_front,

  front_left,
  front_right,
  front_bottom,
  front_top,

  right_right,
  right_left,
  right_bottom,
  right_top,

};


static
void
draw_frame(T&  dst, int  side_length, int  x, int  y, FrameID  fid)
{
    switch(fid)
    {
      case(FrameID::top_front   ): draw_dline(dst,side_length,x+(          0),y+(side_length/2),1, 1);break;
      case(FrameID::top_right   ): draw_dline(dst,side_length,x+(side_length),y+(side_length  ),1,-1);break;


      case(FrameID::top_back    ): draw_dline2(dst,side_length,x+(side_length),y+                 0,1, 1);break;
      case(FrameID::top_left    ): draw_dline2(dst,side_length,x+(          0),y+(side_length/2)-1,1,-1);break;


      case(FrameID::front_bottom): draw_dline(dst,side_length,x+(          0),y+(side_length*2)-(side_length/2)-1,1, 1);break;
      case(FrameID::right_bottom): draw_dline(dst,side_length,x+(side_length),y+(side_length*2)                -1,1,-1);break;

      case(FrameID::front_top   ): draw_dline(dst,side_length,x+(          0),y+(side_length/2)+1,1, 1);break;
      case(FrameID::right_top   ): draw_dline(dst,side_length,x+(side_length),y+(side_length  )+1,1,-1);break;


      case(FrameID::front_left  ): dst.draw_vline(pixel,x+              0,y+side_length-(side_length/2),side_length);break;
      case(FrameID::front_right ): dst.draw_vline(pixel,x+(side_length)-1,y+side_length                ,side_length);break;

      case(FrameID::right_left  ): dst.draw_vline(pixel,x+(side_length  )  ,y+side_length                ,side_length);break;
      case(FrameID::right_right ): dst.draw_vline(pixel,x+(side_length*2)-1,y+side_length-(side_length/2),side_length);break;
      default:;
    }
}


};




#endif




