#ifndef PLANERENDERER_HPP_INCLUDED
#define PLANERENDERER_HPP_INCLUDED




template<typename  T, typename  U>
struct
PlaneRenderer
{


static
void
fill_top(T&  dst, U  pixel, int  side_length, int  x, int  y)
{
  y += (side_length/2)-1;

  dst.draw_hline(pixel,x,y,(side_length*2));


  int  xx = x+2;
  int  yy = y-1;

  int  w = (side_length*2)-4;
  int  n = (side_length/2)-1;

    while(n--)
    {
      dst.draw_hline(pixel,xx,yy,w);

      xx += 2;
      yy -= 1;
       w -= 4;
    }


  ++x;
  ++y;

  w = (side_length*2)-2;
  n = (side_length/2);

    while(n--)
    {
      dst.draw_hline(pixel,x,y,w);

      x += 2;
      y += 1;
      w -= 4;
    }
}


static
void
fill_front(T&  dst, U  pixel, int  side_length, int  x, int  y)
{
  int  h = side_length;

  y += (side_length/2);

  dst.draw_vline(pixel,x,y,h);

  x += 1;
  y += 1;

  int  n = ((side_length/2)-1);

    while(n--)
    {
      dst.draw_vline(pixel,x++,y  ,h);
      dst.draw_vline(pixel,x++,y++,h);
    }


  dst.draw_vline(pixel,x,y,h);
}


static
void
fill_right(T&  dst, U  pixel, int  side_length, int  x, int  y)
{
  int  h = side_length;

  x += side_length;
  y += side_length;

  dst.draw_vline(pixel,x,y,h);

  x += 1;
  y -= 1;

  int  n = (side_length/2)-1;

    while(n--)
    {
      dst.draw_vline(pixel,x++,y  ,h);
      dst.draw_vline(pixel,x++,y--,h);
    }


  dst.draw_vline(pixel,x,y,h);
}


};




#endif




