#include"imp.hpp"
#include<SDL.h>



namespace{


SDL_Window*
window;


SDL_Renderer*
rend;


int  looping;


constexpr RenderingParameter2
rendparam(80,80,80);


Point3D
pt;


void
draw(const Point2D&  a, const Point2D&  b)
{
  SDL_RenderDrawLine(rend,rendparam.x_offset+a.x,
                                             a.y,
                          rendparam.x_offset+b.x,
                                             b.y);
}


constexpr int  l = 16;


void
process_keydown(const SDL_KeyboardEvent&  evt)
{
  auto  st = SDL_GetModState();

  bool  v = st&KMOD_RSHIFT;

    switch(evt.keysym.sym)
    {
      case(SDLK_UP   ): if(v){pt.z-=l;}else{pt.y-=l;}break;
      case(SDLK_LEFT ): pt.x-=l;break;
      case(SDLK_RIGHT): pt.x+=l;break;
      case(SDLK_DOWN ): if(v){pt.z+=l;}else{pt.y+=l;}break;
    }


  printf("\r%3d, %3d, %3d",pt.x,pt.y,pt.z);

  fflush(stdout);
}


void
update()
{
  SDL_SetRenderDrawColor(rend,0,0,0,0);

  SDL_RenderClear(rend);

  SDL_SetRenderDrawColor(rend,255,255,255,255);

  draw(Point3D(pt.x,pt.y,pt.z),Point3D(pt.x  ,pt.y+l,pt.z));
  draw(Point3D(pt.x,pt.y,pt.z),Point3D(pt.x+l,pt.y  ,pt.z));
  draw(Point3D(pt.x  ,pt.y+l,pt.z),Point3D(pt.x+l,pt.y+l,pt.z));
  draw(Point3D(pt.x+l,pt.y  ,pt.z),Point3D(pt.x+l,pt.y+l,pt.z));
  draw(Point3D(pt.x,pt.y,pt.z+l),Point3D(pt.x  ,pt.y+l,pt.z+l));
  draw(Point3D(pt.x,pt.y,pt.z+l),Point3D(pt.x+l,pt.y  ,pt.z+l));
  draw(Point3D(pt.x  ,pt.y+l,pt.z+l),Point3D(pt.x+l,pt.y+l,pt.z+l));
  draw(Point3D(pt.x+l,pt.y  ,pt.z+l),Point3D(pt.x+l,pt.y+l,pt.z+l));

  draw(Point3D(pt.x  ,pt.y+l,pt.z),Point3D(pt.x  ,pt.y+l,pt.z+l));
  draw(Point3D(pt.x+l,pt.y  ,pt.z),Point3D(pt.x+l,pt.y  ,pt.z+l));

  SDL_RenderPresent(rend);
}


}


int
main(int  argc, char**  argv)
{
  SDL_Init(0);

  atexit(SDL_Quit);

  window = SDL_CreateWindow("impdraw - " __DATE__,32,8,rendparam.width,rendparam.height,0);

  rend = SDL_CreateRenderer(window,-1,SDL_RENDERER_SOFTWARE);

  looping = true;

  static SDL_Event  evt;

    while(looping)
    {
        while(SDL_PollEvent(&evt))
        {
            switch(evt.type)
            {
              case(SDL_KEYDOWN):     process_keydown(evt.key);                break;
              case(SDL_QUIT):        looping = false;                break;
            }
        }


      update();

      SDL_Delay(20);
    }


  return 0;
}




