#ifndef WIDGET_HPP
#define WIDGET_HPP


#include"drawer.hpp"
#include"controller.hpp"
#include"rep.hpp"
#include<vector>




struct
Widget
{
  int   width;
  int  height;

  enum class Style{
    flat      ,//平坦
    protrusion,//出っ張り
    hollow    ,//窪み

  } style;


  struct Point{
    int  x;
    int  y;

    constexpr Point(int  x_=0, int  y_=0): x(x_), y(y_){}

    void  set(int  x_, int  y_){x = x_;  y = y_;}

  };


  Point  relative_point;
  Point           point;

  Widget*  parent;

  std::vector<Widget*>  children;

  Widget(int  w=0, int  h=0, Point  pt={0,0});

  void  insert(Widget*  child, int  x=0, int  y=0);

  void  cleanup();

  virtual void  draw(Drawer&  dr);

};


template<typename  T, typename  FN>
struct
Item: public Widget
{
  T*  target;

  Item(T*  p=nullptr, int  w=0, int  h=0): Widget(w,h), target(p){}

  void  draw(Drawer&  dr)
  {
    Widget::draw(dr);

    FN(dr,*target,point.x,point.x);
  }

};


#endif




